# Changelog

## [1.4.0] - ASCII Documentation and Examples Enhancement
### Added
- ASCII schema diagrams in README
- Comprehensive protocol examples
- Demo script for all protocols
- Detailed WHY.md documentation

### Implemented
- System architecture visualization
- Protocol support diagrams
- Development flow charts
- Command structure documentation

### Improvements
- Enhanced documentation clarity
- Better visual representation
- More practical examples
- Clearer usage patterns

## [1.3.0] - Streaming and IoT Protocol Support
### Added
- Streaming protocol support:
  - RTSP for security cameras and live feeds
  - HLS for HTTP Live Streaming
  - DASH for Dynamic Adaptive Streaming
- Enhanced MQTT support for IoT devices:
  - Sensor data handling
  - Device management
  - Smart home automation
- Comprehensive protocol examples

### Implemented
- RTSP handler with TCP/UDP transport
- HLS handler with adaptive bitrate
- DASH handler with quality levels
- IoT device communication patterns
- Streaming protocol validation
- Device status monitoring

### Improvements
- Better protocol handler organization
- Enhanced example documentation
- More comprehensive IoT support
- Streaming configuration validation

## [1.2.0] - HTTP Method Support and Server Enhancements
### Added
- HTTP method configuration for endpoints
- Support for GET, POST, PUT, DELETE, PATCH, OPTIONS
- CORS headers for cross-origin requests
- Method-specific error handling
- Endpoint detachment functionality
- Enhanced server logging

### Implemented
- Method validation in endpoint configuration
- Selective endpoint detachment
- Multi-port server support
- Request method handling
- CORS support

### Improvements
- Better error messages for invalid methods
- Enhanced endpoint configuration
- Improved server logging
- More flexible endpoint management

## [1.1.0] - Protocol Expansion and Process Management
### Added
- New protocol implementations:
  - MQTT for IoT device communication
  - Redis for caching and data storage
  - SMTP for email handling
  - AMQP (RabbitMQ) for message queuing
  - DNS for domain resolution
- Comprehensive protocol examples in examples/protocol_examples/
- Enhanced process management with robust error handling

### Implemented
- Protocol-specific handlers with validation
- Example implementations for each new protocol
- Improved process management with proper argument handling
- Thread-safe operations in process management

### Improvements
- Enhanced error propagation in process management
- More robust protocol validation
- Expanded test coverage
- Updated documentation for new protocols

## [1.0.0] - Stable Release and Major Feature Consolidation
[Rest of changelog remains unchanged...]
